︠cc975e1a-0ea0-457b-8583-b7e7183462e2i︠
%md
### [fricas-CR](https://github.com/billpage/fricas-CR) is an extension of [FriCAS](https://sourceforge.net/projects/fricas/) ###
that implements the calculus of differentiable functions over an involutive algebra of symbolic expressions -- functions of complex variables.
︡b4195d87-cf2e-409f-bdd1-8cfdfff41ba9︡{"done":true,"md":"### [fricas-CR](https://github.com/billpage/fricas-CR) is an extension of [FriCAS](https://sourceforge.net/projects/fricas/) ###\nthat implements the calculus of differentiable functions over an involutive algebra of symbolic expressions -- functions of complex variables."}
︠b1565b10-cb5d-4079-bcdb-a370fda707a1i︠
%html
<h4>
    To run a customized version of FriCAS in a Sage worksheet
</h4>
The following Sage/Python command modifies the PATH variable to include $HOME/bin. Sage looks for the fricas executable in this PATH.
︡626c8e00-60e9-48a7-8fae-95d477fdc594︡{"done":true,"html":"<h4>\n    To run a customized version of FriCAS in a Sage worksheet\n</h4>\nThe following Sage/Python command modifies the PATH variable to include $HOME/bin. Sage looks for the fricas executable in this PATH."}
︠b361ecf1-8d37-4fca-98c2-4a2fcc8c6b6cs︠
os.environ['PATH'] = '%s/bin:%s'%(os.environ['HOME'],os.environ['PATH'])
︡020b65d4-38ef-41c1-8344-ff75425ad66f︡{"done":true}︡
︠1889efda-ca87-4033-a26c-ce117324f743i︠
%html
<h4>
    To typeset the output of FriCAS
</h4>
A mode in SageMathCloud is just a function that takes as input a string.
For example, this function takes whatever the cells input is, executes the
code in Fricas, then takes the output and displays it using Markdown:

︡b3585785-5261-4b82-9e1c-e111f5ef883b︡{"done":true,"html":"<h4>\n    To typeset the output of FriCAS\n</h4>\nA mode in SageMathCloud is just a function that takes as input a string.\nFor example, this function takes whatever the cells input is, executes the\ncode in Fricas, then takes the output and displays it using Markdown:"}
︠4e687b76-c660-4b82-b968-ec5c6e9486a5s︠
%sage
from fricas import fricas
def fricas_md(s):
    import re
    t = fricas.eval(s)
    #print t
    t=re.compile(r'\r').sub('',t)
    # mathml overbar
    t=re.compile(r'&#x000AF;').sub('&#x203E;',t,count=0)
    # cleanup FriCAS LaTeX
    t=re.compile(r'\\leqno\(.*\)\n').sub('',t)
    t=re.compile(r'\\sb ').sub('_',t,count=0)
    t=re.compile(r'\\sp ').sub('^',t,count=0)
    # float result type to the right
    t=re.compile(r' *Type: (.*)\n').sub(r'<p style="text-align:right">Type: \1</p>',t,count=0)
    #print t
    md(t, hide=False)
︡c948c27a-d662-4b9f-8c23-c35daac7b435︡{"done":true}︡
︠352571c7-9f66-4c92-9183-acf9c7ea81b5s︠
%default_mode fricas_md
︡c4331352-9628-4a36-851d-254c89640375︡{"done":true}︡
︠3a89ddbd-ed85-4cc1-b3e7-ee7f4f09bcbcs︠
)set output mathml off
)set output tex on
)set output algebra off
︡3f27b1c5-ca11-4a73-96ec-2444afecc34e︡{"md":"\n\n"}︡{"done":true}︡
︠b43e384f-7662-49b9-be70-4dcf564b6166i︠
%md
This version of fricas-CR was compiled on
︡5611858f-f3d9-43e0-8fdf-b3dfd8866fd3︡{"done":true,"md":"This version of fricas-CR was compiled on"}
︠74526fc1-7e9f-43f2-a2f2-87b8f7f5a1a6s︠
)version
︡aac25a1c-aedc-4299-849b-15da538a0bbf︡{"md":"\nValue = \"FriCAS 2017-08-05 compiled at Fri Dec 22 00:46:50 UTC 2017\"\n"}︡{"done":true}︡
︠35f7a7a4-f837-49dc-b717-d387fc5b7b3ei︠
%md
In fricas-CR every symbol has a conjugate that can appear in polynomials and more general expressions.
︡91ae196c-f5fc-4e03-8b9a-262f640fd16d︡{"done":true,"md":"In fricas-CR every symbol has a conjugate that can appear in polynomials and more general expressions."}
︠770997b0-bb7f-42c3-8ae7-9021ec644c4fs︠
conjugate(x)
︡f413b7a8-d040-458b-8a99-976044e37118︡{"md":"\n$$\n\\overline x \n$$\n\n<p style=\"text-align:right\">Type: Symbol</p>"}︡{"done":true}︡
︠cafb3876-13b3-4e58-b893-62cad446b004s︠
conjugate conjugate(x)
︡842754c5-c048-4647-a48f-084a95cbe682︡{"md":"\n$$\nx \n$$\n\n<p style=\"text-align:right\">Type: Symbol</p>"}︡{"done":true}︡
︠08926d51-f5fe-418e-b62a-259d08a23751s︠
x+conjugate(x)
︡b705b05a-e03b-49a8-9d7c-ba8aada20a3c︡{"md":"\n$$\n{\\overline x}+x \n$$\n\n<p style=\"text-align:right\">Type: Polynomial(Integer)</p>"}︡{"done":true}︡
︠7e3ef482-8b5d-41d1-8f01-4a2c66a30ef3s︠
real(x)==(x+conjugate(x))/2
︡0aa588ff-ff7c-4af8-adbe-f99ae44c303e︡{"md":"<p style=\"text-align:right\">Type: Void</p>"}︡{"done":true}︡
︠c6d972bd-9aff-44af-b4ba-6be821b6303bs︠
sin(real x)
︡e56fcaeb-f458-442c-8474-63d0cce460d0︡{"md":"   Compiling function real with type Variable(x) -> Polynomial(Fraction(Integer)) \n\n$$\n\\sin \n\\left(\n{{{{\\overline x}+x} \\over 2}} \n\\right)\n$$\n\n<p style=\"text-align:right\">Type: Expression(Integer)</p>"}︡{"done":true}︡
︠202e840b-bc7c-4154-adaf-a5c0d6345b5ai︠
%md
Every symbolic operator has a conjugate but no other assumptions are made.
︡097f95aa-e597-466c-bfb4-a9772cbbb765︡{"done":true,"md":"Every symbolic operator has a conjugate but no other assumptions are made."}
︠78ead5b6-8d8a-4b6c-8c13-39a5cf0e0c98s︠
f:=operator 'f
conjugate f
conjugate f(x)
︡025a1c03-ed57-4d8f-aed2-918d27539353︡{"md":"\n$$\nf \n$$\n\n<p style=\"text-align:right\">Type: BasicOperator</p>\n\n$$\n\\overline f \n$$\n\n<p style=\"text-align:right\">Type: BasicOperator</p>\n\n$$\n{\\overline f} \n\\left(\n{x} \n\\right)\n$$\n\n<p style=\"text-align:right\">Type: Expression(Integer)</p>"}︡{"done":true}︡
︠3ee8f240-177e-4b23-ab0b-fe4daae94d67s︠
g:=operator 'g
conjugate g(x)
︡6dab87f3-c108-43d9-a45f-a87803428236︡{"md":"\n$$\ng \n$$\n\n<p style=\"text-align:right\">Type: BasicOperator</p>\n\n$$\n{\\overline g} \n\\left(\n{x} \n\\right)\n$$\n\n<p style=\"text-align:right\">Type: Expression(Integer)</p>"}︡{"done":true}︡
︠17de94b4-6305-4749-bb9c-8f1661d3ada7i︠
%md
### Wirtinger chain rule
fricas-CR implements the [Wirtinger derivative](http://en.wikipedia.org/wiki/Wirtinger_derivatives)
︡2ade6047-8b3e-42af-a6e0-bd4b7e8947b2︡{"done":true,"md":"### Wirtinger chain rule\nfricas-CR implements the [Wirtinger derivative](http://en.wikipedia.org/wiki/Wirtinger_derivatives)"}
︠ee2aa80b-4fce-4362-907a-fb16930622f0s︠
differentiate(f(g x),x)
︡fe604194-e32c-4536-92ec-37967a9fc0fd︡{"md":"\n$$\n{{{{\\overline g} _{\\verb#\" \"#} ^{,}} \n\\left(\n{x} \n\\right)}\n\\  {\\overline {{{\\overline f} _{\\verb#\" \"#} ^{,}} \n\\left(\n{{g \n\\left(\n{x} \n\\right)}}\n\\right)}}}+{{{f\n_{\\verb#\" \"#} ^{,}} \n\\left(\n{{g \n\\left(\n{x} \n\\right)}}\n\\right)}\n\\  {{g _{\\verb#\" \"#} ^{,}} \n\\left(\n{x} \n\\right)}}\n$$\n\n<p style=\"text-align:right\">Type: Expression(Integer)</p>"}︡{"done":true}︡
︠fc4d33b8-530a-470b-8c9d-099b470a64c7s︠
differentiate(f(g x),conjugate x)
︡88eb555c-979b-43ab-b7f7-e6b0ce3a17f0︡{"md":"\n$$\n{{{f _{\\verb#\" \"#} ^{,}} \n\\left(\n{{g \n\\left(\n{x} \n\\right)}}\n\\right)}\n\\  {\\overline {{{\\overline g} _{\\verb#\" \"#} ^{,}} \n\\left(\n{x} \n\\right)}}}+{{\\overline\n{{{\\overline f} _{\\verb#\" \"#} ^{,}} \n\\left(\n{{g \n\\left(\n{x} \n\\right)}}\n\\right)}}\n\\  {\\overline {{g _{\\verb#\" \"#} ^{,}} \n\\left(\n{x} \n\\right)}}}\n$$\n\n<p style=\"text-align:right\">Type: Expression(Integer)</p>"}︡{"done":true}︡
︠f41923a5-b890-42f1-ae56-2ecef34482cas︠
test(differentiate(f(g x),conjugate x)=conjugate differentiate(conjugate f(g x),x))
︡f7317beb-a04e-4b69-99f9-95083f5570b9︡{"md":"\n$$\ntrue \n$$\n\n<p style=\"text-align:right\">Type: Boolean</p>"}︡{"done":true}︡
︠de6fc524-1703-45d8-b9a4-9c8670022710s︠
differentiate(f conjugate x,x)
︡f6053339-9ddd-49dc-b31a-07c7609d265a︡{"md":"\n$$\n\\overline {{{\\overline f} _{\\verb#\" \"#} ^{,}} \n\\left(\n{{\\overline x}} \n\\right)}\n$$\n\n<p style=\"text-align:right\">Type: Expression(Integer)</p>"}︡{"done":true}︡
︠dc8481e6-c0f5-432c-bc2a-12ea9d975bacs︠
differentiate(f conjugate x, conjugate x)
︡700a08e7-5845-4905-9778-008e8ec034d1︡{"md":"\n$$\n{f _{\\verb#\" \"#} ^{,}} \n\\left(\n{{\\overline x}} \n\\right)\n$$\n\n<p style=\"text-align:right\">Type: Expression(Integer)</p>"}︡{"done":true}︡
︠31877fd8-53ef-4a95-98c6-fc3c72e6aaa6s︠
differentiate(f(x,conjugate x),x)
︡ae746fa2-fccc-4ca8-82e9-e3d7cacfe604︡{"md":"\n$$\n{\\overline {{{\\overline f} _{{,2}}} \n\\left(\n{x, \\: {\\overline x}} \n\\right)}}+{{f\n_{{,1}}} \n\\left(\n{x, \\: {\\overline x}} \n\\right)}\n$$\n\n<p style=\"text-align:right\">Type: Expression(Integer)</p>"}︡{"done":true}︡
︠df0b4d14-d608-4778-8764-5896ae702ec6s︠
differentiate(f(x,conjugate x),conjugate x)
︡bfe6873b-74f3-41fb-97c5-114aa622b896︡{"md":"\n$$\n{\\overline {{{\\overline f} _{{,1}}} \n\\left(\n{x, \\: {\\overline x}} \n\\right)}}+{{f\n_{{,2}}} \n\\left(\n{x, \\: {\\overline x}} \n\\right)}\n$$\n\n<p style=\"text-align:right\">Type: Expression(Integer)</p>"}︡{"done":true}︡
︠6a76de18-39b8-41ba-b63b-129ec8b6c305i︠
%md
Conjugation commutes with holomorphic functions and the conjugate derivative is zero due to Cauchy-Riemann.
︡abc86389-eb99-4749-aec1-7ee240db1bae︡{"done":true,"md":"Conjugation commutes with holomorphic functions and the conjugate derivative is zero due to Cauchy-Riemann."}
︠704c0750-e1ee-4f56-8ebf-71129f22c482s︠
h:=holomorphic operator 'h
conjugate h(x)
︡b61b4dd0-7252-4df0-873b-d5fba6dbe3b6︡{"md":"\n$$\nh \n$$\n\n<p style=\"text-align:right\">Type: BasicOperator</p>\n\n$$\nh \n\\left(\n{{\\overline x}} \n\\right)\n$$\n\n<p style=\"text-align:right\">Type: Expression(Integer)</p>"}︡{"done":true}︡
︠0cb3c87b-f579-416b-9276-ae52bce70124s︠
differentiate(h(x),conjugate x)
︡e29d0c9a-303d-4106-8fda-df78b5f074d4︡{"md":"\n$$\n0 \n$$\n\n<p style=\"text-align:right\">Type: Expression(Integer)</p>"}︡{"done":true}︡
︠76fab5bc-87de-4dc4-8274-2037e82b86a7i︠
%md
Many common functions are holomorphic, e.g.
︡b190e8f4-a843-429b-934a-0f7abd79eb4e︡{"done":true,"md":"Many common functions are holomorphic, e.g."}
︠256001c5-44e0-4f05-af64-e8a8bfec9d64s︠
conjugate sin(x)
differentiate(sin x,conjugate x)
︡67a58214-6c44-4eb3-9ae9-fc8eeb50ed2c︡{"md":"\n$$\n\\sin \n\\left(\n{{\\overline x}} \n\\right)\n$$\n\n<p style=\"text-align:right\">Type: Expression(Integer)</p>\n\n$$\n0 \n$$\n\n<p style=\"text-align:right\">Type: Expression(Integer)</p>"}︡{"done":true}︡
︠64c85899-cfb7-4d0e-bd58-154600ff063es︠
differentiate(sin conjugate x,x)
︡908d865c-bc43-4488-bc86-308482bd7e0c︡{"md":"\n$$\n0 \n$$\n\n<p style=\"text-align:right\">Type: Expression(Integer)</p>"}︡{"done":true}︡
︠35b51c53-3d2a-456a-9328-a21f6bfa512di︠
%md
The following definition for the conjugate of $ \sqrt{\ } $
︡5bf1c339-ae9b-4d61-b656-6d38822be823︡{"done":true,"md":"The following definition for the conjugate of $ \\sqrt{\\ } $"}
︠e366cecb-f038-41f2-ac26-f633c6ddb60ds︠
conjugate sqrt(x)
︡a8691830-94f6-40d8-a5d1-40d1e4c02b00︡{"md":"\n$$\n1 \\over {\\sqrt {{1 \\over {\\overline x}}}} \n$$\n\n<p style=\"text-align:right\">Type: Expression(Integer)</p>"}︡{"done":true}︡
︠d306b551-14ab-43eb-b7ff-c301e12f6b54i︠
%md
makes $ \sqrt{\ } $ a holomorphic function.
︡9dfcb2a9-5880-4ad3-bb62-3292691b5999︡{"done":true,"md":"makes $ \\sqrt{\\ } $ a holomorphic function."}
︠9e8c7dd5-1421-40b3-a8a5-60a368fd6df3s︠
differentiate(sqrt x,conjugate x)
︡e20f4e76-dd88-4261-8b89-e17fe7183f03︡{"md":"\n$$\n0 \n$$\n\n<p style=\"text-align:right\">Type: Expression(Integer)</p>"}︡{"done":true}︡
︠587f851b-73ae-47c9-ac56-227cd3971f7es︠
conjugate(sqrt(-1))
︡cc86107a-7762-4d31-9dad-f46e759dd029︡{"md":"\n$$\n1 \\over {\\sqrt {-1}} \n$$\n\n<p style=\"text-align:right\">Type: Expression(Integer)</p>"}︡{"done":true}︡
︠79be37bf-6ed6-481c-8047-bbbde2ce8427s︠
retract %
︡f26e1579-5ac9-4a7b-aacd-f930686430fd︡{"md":"\n$$\n-{\\sqrt {-1}} \n$$\n\n<p style=\"text-align:right\">Type: AlgebraicNumber</p>"}︡{"done":true}︡
︠4db145d4-d40c-4bdd-a5e2-c4d48fc0b998s︠
cin:=conjugate operator(operator('sin))$Expression Integer
︡0f47de01-bf36-43f3-8523-f58a7a0792ac︡{"md":"\n$$\n\\overline \\sin \n$$\n\n<p style=\"text-align:right\">Type: BasicOperator</p>"}︡{"done":true}︡
︠c795d205-da9a-4476-825e-6674df19c1a3s︠
cin(x)
︡f9aaa8b9-0f94-4ebd-9cbe-b17e4d962cf1︡{"md":"\n$$\n{\\overline \\sin} \n\\left(\n{x} \n\\right)\n$$\n\n<p style=\"text-align:right\">Type: Expression(Integer)</p>"}︡{"done":true}︡
︠6a2aad3f-666c-4a7e-872e-997ca0c732b2s︠
conjugate %
︡22a00c0e-a4b1-411a-9c2b-e10a37b358d5︡{"md":"\n$$\n\\sin \n\\left(\n{x} \n\\right)\n$$\n\n<p style=\"text-align:right\">Type: Expression(Integer)</p>"}︡{"done":true}︡
︠930b9080-bdfd-42ca-b856-c7d83acb875fs︠
conjugate(sin(x))
︡81301961-bda2-4d7a-b1bf-ee088ac35bda︡{"md":"\n$$\n\\sin \n\\left(\n{{\\overline x}} \n\\right)\n$$\n\n<p style=\"text-align:right\">Type: Expression(Integer)</p>"}︡{"done":true}︡
︠40540db6-6b51-4f71-9bce-f4c144806066s︠
sin(1- %i)
︡f3720f5e-b04f-464d-963d-2e7ed5a32f57︡{"md":"\n$$\n\\sin \n\\left(\n{{1 -i}} \n\\right)\n$$\n\n<p style=\"text-align:right\">Type: Expression(Complex(Integer))</p>"}︡{"done":true}︡
︠7943edb2-ed52-471b-a997-daba14223396s︠
︡39a235f4-60a1-4c44-9cca-ba60ff2513dc︡{}︡{"done":true}︡
︠d984cf76-09e3-429e-b603-3e490fb0b77cs︠
conjugate %
︡ad8eca55-4c84-4e64-a491-22876a561b2b︡{"md":"\n$$\n\\sin \n\\left(\n{{1+i}} \n\\right)\n$$\n\n<p style=\"text-align:right\">Type: Expression(Complex(Integer))</p>"}︡{"done":true}︡
︠cb6cf2d8-a40b-4c4f-b38c-ea4db1b1bd2ds︠
simplify %
︡752b51ca-6c5f-42bb-b90e-eccad50f9391︡{"md":"\n$$\n\\sin \n\\left(\n{{1+i}} \n\\right)\n$$\n\n<p style=\"text-align:right\">Type: Expression(Complex(Integer))</p>"}︡{"done":true}︡
︠33163c62-c67c-4f16-820f-828c3d7f3a5fs︠
expand %
︡32b2dfd3-b031-4001-93a9-031dced72b2a︡{"md":"\n$$\n\\sin \n\\left(\n{{1+i}} \n\\right)\n$$\n\n<p style=\"text-align:right\">Type: Expression(Complex(Integer))</p>"}︡{"done":true}︡
︠4e83790e-607f-4d0b-b626-0096af15ec2cs︠
simplify %
︡ada50a5e-6b4b-4116-9b26-ba44caa05480︡{"md":"\n$$\n\\sin \n\\left(\n{{1+i}} \n\\right)\n$$\n\n<p style=\"text-align:right\">Type: Expression(Complex(Integer))</p>"}︡{"done":true}︡
︠b972a506-220f-493c-a6ab-0228f90d702bs︠
︡348f150f-5e53-4319-8241-5abd37696923︡{}︡{"done":true}︡
︠5c7765ec-4256-493c-8f45-a070a64e55ffs︠

︡b5afdd07-5a35-4c5a-98ac-87d70dec57e3︡{}︡{"done":true}︡









